"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class TumorChecks(ProtocolElement):
    """
    Tumor contamination check results  We ask whether somatic calls are
    common in 1000G project.  Common is defined as 0.01.  The
    percentage of these variants gives an indication of the
    contamination level of the sample.  If another sample contaminates
    or the germline is swapped then the percentage of somatic variants
    in 1000G will be high.  * `well_id`: Individual sample ID *
    `num_variants_gt_filter`: The number of somatic variants that are
    common in 1000G * `num_variants_lt_filter`: The number of somatic
    variants rare or nonexistant in 1000G * `perc_variants_gt_filter`:
    The percentage of somatic variants that are common in 1000G
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "TumorContaminationContEst",
        "num_variants_gt_filter",
        "num_variants_lt_filter",
        "perc_variants_gt_filter",
        "well_id",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import metrics as metrics_1_2_2

        return {
            "org.gel.models.report.avro.TumorChecks": metrics_1_2_2.TumorChecks,
        }

    __slots__ = [
        "TumorContaminationContEst",
        "num_variants_gt_filter",
        "num_variants_lt_filter",
        "perc_variants_gt_filter",
        "well_id",
    ]

    def __init__(
        self,
        TumorContaminationContEst,
        num_variants_gt_filter,
        num_variants_lt_filter,
        perc_variants_gt_filter,
        well_id,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_2.TumorChecks model.

        :param TumorContaminationContEst:
        :type TumorContaminationContEst: double
        :param num_variants_gt_filter:
        :type num_variants_gt_filter: double
        :param num_variants_lt_filter:
        :type num_variants_lt_filter: double
        :param perc_variants_gt_filter:
        :type perc_variants_gt_filter: double
        :param well_id:
        :type well_id: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.2"
